/***************************************************************************
                          console.c  -  description
                             -------------------
    begin                : Sun Jan 2 2000
    copyright            : (C) 2000 by Eugene S. Weiss
    email                : eweiss@sas.upenn.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*  Thses provide an interacive text based interface to the driver. Eventually
there will be a choice of interfaces, graphic, gui, GIMP plugin, SANE, etc.,
but for now this will do.*/

#include "as6edriver.h"
#include "regdata.h"
#include "prototypes.h"

/*--------------------------------------------------------------------------*/
//draws an ascii picture of the scanner so the user won't get confused about
//front - back, right -left questions

void draw_scanner(void)
{

    printf("\n\n\n");
    printf("\n                 Back");
    printf("\n                __________");
    printf("\n          11.7\"|         |");
    printf("\n               |         |");
    printf("\n             L |  AS6E   | R ");
    printf("\n             e |         | i ");
    printf("\n             f | .     . | g ");
    printf("\n             t | .     . | h ");
    printf("\n               | .     . | t ");
    printf("\n               |  .   .  |");
    printf("\n               |   . .   |");
    printf("\n             0 |_________|8.5\"");
    printf("\n autoscan button  -|__|");
    printf("\n                   Front ");
}

/*--------------------------------------------------------------------------*/

unsigned short get_stopline(unsigned short startline,
			    unsigned short stopline)
{

    float choice = 0, start;
    start = startline / 300;

    while (choice != 99) {
	printf
	    ("\nPlease enter the distance from the front you would like to end your scan,");
	printf("\nor enter 99 to quit the AS6E driver.");
	printf
	    ("\nThe maximum is 11.7 inches, representing the rear of the scanable area.");
	printf("\n\nEnter choice # ");
	scanf("%f", &choice);
	if (choice == 99)
	    return (9999);
	if (start < choice < 11.7)
	    return (choice * 300);
	printf
	    ("Sorry, %f is not a valid choice.  \nThe number must be greater than %f and less than 11.7 inches.",
	     choice, start);
    }
    return (-1);
}

/*--------------------------------------------------------------------------*/

unsigned short get_startline(unsigned short startline)
{

    float choice = 0;
    draw_scanner();

    while (choice != 99) {
	printf
	    ("\nPlease enter the distance from the front you wold like to start your scan,");
	printf("\nor enter 99 to quit the AS6E driver.");
	printf
	    ("\n\nUnits are in inches.  Use the decimal point to specify fractions.");
	printf("\nOne inch = 2.54 centimeters.");
	printf
	    ("\nThe maximum is 11.7 inches, representing the front of the scanable area");
	printf("\n\nEnter choice # ");
	scanf("%f", &choice);
	if (choice == 99)
	    return (9999);
	if (0 <= choice < 11.7)
	    return (choice * 300);
	printf
	    ("Sorry, %f is not a valid choice.  The number must be less than 11.7 inches.",
	     choice);
    }
    return (-1);
}

/*--------------------------------------------------------------------------*/

unsigned short get_stoppos(unsigned short startpos, unsigned short stoppos)
{

    float choice = 0, start;
    start = startpos / 300;

    while (choice != 99) {
	printf
	    ("\nPlease enter the distance from the left edge you would like to end your scan,");
	printf("\nor enter 99 to quit the AS6E driver.");
	printf
	    ("\nThe maximum is 8.5 inches, representing the right edge of the scanable area.");
	printf("\n\nEnter choice # ");
	scanf("%f", &choice);
	if (choice == 99)
	    return (9999);
	if (start < choice < 8.5)
	    return (choice * 300);
	printf
	    ("Sorry, %f is not a valid choice.  \nThe number must be greater than %f and less than 8.5 inches.\n",
	     choice, start);
    }
    return (-1);
}

/*--------------------------------------------------------------------------*/

unsigned short get_startpos(unsigned short startpos)
{

    float choice = 0;
    draw_scanner();

    while (choice != 99) {
	printf
	    ("\nPlease enter the distance from the left edge you would like to start your scan,");
	printf("\nor enter 99 to quit the AS6E driver.");
	printf
	    ("\n\nUnits are in inches.  Use the decimal point to specify fractions.");
	printf("\nOne inch = 2.54 centimeters.");
	printf
	    ("\nThe maximum is 8.5 inches, representing the right edge of the scanable area");
	printf("\n\nEnter choice # ");
	scanf("%f", &choice);
	if (choice == 99)
	    return (9999);
	if (0 <= choice < 8.5)
	    return (choice * 300);
	printf
	    ("Sorry, %f is not a valid choice.  The number must be less than 8.5 inches.\n",
	     choice);
    }
    return (-1);
}

/*--------------------------------------------------------------------------*/

unsigned char get_color(unsigned char color)
{

    int choice = 0;

    while (choice != 9) {
	printf
	    ("\n\n\n\n\nPlease enter the color mode for the scan.\n\nEnter    for  color mode");
	printf("\n\n  1      for    Color");	//spelling proudly American :)
	printf("\n  2      for    Greyscale");
	printf("\n  3      for    Lineart");
	printf("\n\nEnter 9 to quit the AS6E driver.\n\nEnter choice # ");
	scanf("%d", &choice);

	if (choice == 1)
	    return (COLOR);
	if (choice == 2) {
	    lineart = 0;
	    return (GREYSCALE);
	}
	if (choice == 3) {
	    lineart = 1;
	    return (GREYSCALE);
	}
	if (choice == 9)
	    return (99);
	printf("\nSorry, %d is not a valid choice.  Please try again.\n",
	       choice);
    }
    return (-1);
}

/*--------------------------------------------------------------------------*/

unsigned char get_resolution(unsigned char resolution)
{

    int choice = 0;

    while (choice != 9) {
	printf
	    ("\n\nPlease enter the resolution for the scan.\n\nEnter    for  Resolution");
	printf("\n\n  1      for    50  dpi");
	printf("\n  2      for    100 dpi");
	printf("\n  3      for    200 dpi");
	printf("\n  4      for    300 dpi");
	printf("\n\nEnter 9 to quit the AS6E driver.\n\nEnter choice # ");
	scanf("%d", &choice);

	if (choice == 1)
	    return (DPI50);
	if (choice == 2)
	    return (DPI100);
	if (choice == 3)
	    return (DPI200);
	if (choice == 4)
	    return (DPI300);
	if (choice == 9)
	    return (99);
	printf
	    ("\nI'm sorry, %d is not a valid choice.  Please try again.\n",
	     choice);
    }
    return (-1);
}

/*--------------------------------------------------------------------------*/

void welcome_message(void)
{
    printf("\n\n            Welcome to the Artec AS6E driver for Linux.");
    printf("\n                          version %s", VERSION);
    printf("\n                        (c) Eugene Weiss\n");
    printf
	("					 This program is licensed under the GNU GPL.");
    printf("\n           Homepage http://as6edriver.sourceforge.net\n");
}

/*--------------------------------------------------------------------------*/

int console(int port)
{

    int test, scan_again, divisor = 1;
    unsigned char color = 0, resolution = 99;
    unsigned short startpos = 9999, stoppos = 9999, startline =
	9999, stopline = 9999;

    test = check_for_scanner(port);
    if (test == 0)
	return (0);
    welcome_message();

    while (scan_again != 9) {
	resolution = get_resolution(resolution);
	if (resolution == 99)
	    return (1);

	color = get_color(color);
	if (color == 99)
	    return (1);

	startpos = get_startpos(startpos);
	if (startpos == 9999)
	    return (1);

	stoppos = get_stoppos(startpos, stoppos);
	if (stoppos == 9999)
	    return (1);

	startline = get_startline(startline);
	if (startline == 9999)
	    return (1);

	stopline = get_stopline(startline, stopline);
	if (stopline == 9999)
	    return (1);

	if ((resolution == DPI200) || (resolution == DPI100))
	    divisor = 3;
	else if (resolution == DPI50)
	    divisor = 6;	//get legal values for 200 dpi
	startpos = (startpos / divisor) * divisor;
	stoppos = (stoppos / divisor) * divisor;
	startline = (startline / divisor) * divisor;
	stopline = (stopline / divisor) * divisor;


	printf("\nScanning.");

	scan(port, resolution, color, startpos, stoppos, startline,
	     stopline);

	while (scan_again) {
	    printf
		("\n\n\nEnter 1 to make a new scan with the same settings.");
	    printf
		("\nEnter 2 to make a new scan with different settings.");
	    printf("\nEnter 9 to quit the AS6E driver.");
	    printf("\n\nPlease enter a number # ");
	    scanf("%d", &scan_again);

	    if (scan_again == 1)
		scan(port, resolution, color, startpos, stoppos, startline,
		     stopline);
	    if (scan_again == 2)
		break;
	    if (scan_again == 9)
		return (1);
	    if (scan_again != 1)
		printf
		    ("\n\nI'm sorry, I don't recognize option %d.  Please try again.",
		     scan_again);
	}
    }
    return (-1);
}
