/***************************************************************************
                          prototypes.h  -  description
                             -------------------
    begin                : Thu Dec 30 1999
    copyright            : (C) 1999 by Eugene S. Weiss
    email                : eweiss@sas.upenn.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
void scan(int port, unsigned char resolution, unsigned char color,
	  unsigned short startpos, unsigned short stoppos,
	  unsigned short startline, unsigned short stopline);

void test13(int port);
void test12(int port);
void test11(int port);
void test9(int port);
void test8(int port);
void test7(int port);
void test6(int port);
void test5(int port);
void test4(int port);
void test3(int port);
void test2(int port);
void test1(int port);

int iopl(int level);		//compiler stupidly generates a warning if this line isn't here

void wake_up_scanner(int port);

void *xmalloc(size_t size);

void initialize_regdata(void);

void write_register(int port, int regnumber, unsigned short data);

unsigned short read_register(int port, int regnumber);

void test0(int port);

void test14(int port);

inline unsigned short readbuf(int port, unsigned char *buffer, int length);

inline void clear_epp_timeout(int port);

unsigned char **calibrate(int port, unsigned char resolution,
			  unsigned char color);

int check_for_scanner(int port);

void testsuite(int port);

void cmd_line(int port, int argc, char **argv);
int console(int port);
void sane(int port);

unsigned char nibble_in(int port, unsigned char addr);
unsigned char byte_me(int port, unsigned char addr);
unsigned char epp_in(int port, unsigned char addr);

inline void clear_epp_timeout(int port);

void set_mode(int port, unsigned char newecrmode, unsigned char newmode);

void get_dark_values(int port, unsigned char resolution,
		     unsigned char color, unsigned short startpos,
		     unsigned short stoppos);

void get_light_values(int port, unsigned char resolution,
		      unsigned char color, unsigned short startpos,
		      unsigned short stoppos, unsigned char *redbuf,
		      unsigned char *greenbuf, unsigned char *bluebuf);

void write_pnm_headers(FILE * fd, unsigned char color,
		       unsigned short bytes_per_line,
		       unsigned short lines);

inline unsigned char bytesize(int value);

void cancel(int sig);

void wait_home(int port);

unsigned char **init_data_array(unsigned short rows,
				unsigned short coloumns);

int get_port_address(void);



double red_correct[2550], green_correct[2550], blue_correct[2550];
unsigned char red_dark[2550], green_dark[2550], blue_dark[2550];

int lineart;

unsigned short redtime;
unsigned short greentime;
unsigned short bluetime;

unsigned char MODE;
unsigned char ECRMODE;
#define ECR_NIBBLE 0
#define ECR_BYTE 0x20
#define ECR_EPP 0x80

int uimode, cancelled;

int ctloutpipe, ctlinpipe, datapipe;
#define SANEUI 3

FILE *LOGd;

double brightness, decontrast, redadjust, greenadjust, blueadjust,
    led_bright_adjust;
