/***************************************************************************
                          regdata.c  -  description
                             -------------------
    begin                : Sat Dec 25 1999
    copyright            : (C) 1999 by Eugene S. Weiss
    email                : eweiss@sas.upenn.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*  This function sets up the register data from the Artec documentation.
		
		It includes ALL of the registers listed, with as much info as I was able
    	understand about the registers.  Many registers will not be used in the
		driver, (does anyone really have the sheet-fed version of this scanner?)
		but I have included them here anyway, to make extension of the driver's
		capabilities easier,and in case other Artec scanners use the same
		interface.  For info on HOW to use the registers, see the header file
		regdata.h.
*/

  //initialize the array of registers
#include "as6edriver.h"
#include "regdata.h"
#include "prototypes.h"

void initialize_regdata(void)
{

    REGISTER[primary_register].low = 0x01;
    REGISTER[primary_register].type = BYTE;

    REGISTER[status_control_register].low = 0x02;
    REGISTER[status_control_register].type = BYTE;

    REGISTER[configure_setting_register].low = 0x03;
    REGISTER[configure_setting_register].type = BYTE;

    REGISTER[scan_mode_register].low = 0x04;
    REGISTER[scan_mode_register].type = BYTE;

    REGISTER[line_time_register].low = 0x05;
    REGISTER[line_time_register].high = 0x06;
    REGISTER[line_time_register].type = WORD;

    REGISTER[image_pixel_start].low = 0x07;
    REGISTER[image_pixel_start].high = 0x08;
    REGISTER[image_pixel_start].type = WORD;

    REGISTER[image_pixel_stop].low = 0x09;
    REGISTER[image_pixel_stop].high = 0x0A;
    REGISTER[image_pixel_stop].type = WORD;

    REGISTER[lineart_threshold_up].low = 0x0b;
    REGISTER[lineart_threshold_up].type = BYTE;

    REGISTER[lineart_threshold_down].low = 0x2a;
    REGISTER[lineart_threshold_down].type = BYTE;

    REGISTER[empty_image_line_register].low = 0x0c;
    REGISTER[empty_image_line_register].high = 0x0d;
    REGISTER[empty_image_line_register].type = WORD;

    REGISTER[motor_steps_register].low = 0x0e;
    REGISTER[motor_steps_register].high = 0x0f;
    REGISTER[motor_steps_register].type = WORD;

    REGISTER[motor_rotation_speed].low = 0x10;
    REGISTER[motor_rotation_speed].high = 0x11;
    REGISTER[motor_rotation_speed].type = WORD;

    REGISTER[led_control].low = 0x12;
    REGISTER[led_control].type = BYTE;

    REGISTER[red_led_on_time].low = 0x13;
    REGISTER[red_led_on_time].high = 0x14;
    REGISTER[red_led_on_time].type = WORD;

    REGISTER[green_led_on_time].low = 0x15;
    REGISTER[green_led_on_time].high = 0x16;
    REGISTER[green_led_on_time].type = WORD;

    REGISTER[blue_led_on_time].low = 0x17;
    REGISTER[blue_led_on_time].high = 0x18;
    REGISTER[blue_led_on_time].type = WORD;

    REGISTER[max_lines_register].low = 0x19;
    REGISTER[max_lines_register].type = BYTE;

    REGISTER[bytes_per_line_register].low = 0x1c;
    REGISTER[bytes_per_line_register].high = 0x1d;
    REGISTER[bytes_per_line_register].type = WORD;

    REGISTER[sram_test_register].low = 0x1e;
    REGISTER[sram_test_register].type = BYTE;

    REGISTER[buffer_addr_test_register].low = 0x1f;
    REGISTER[buffer_addr_test_register].high = 0x21;
    REGISTER[buffer_addr_test_register].type = WORD;

    REGISTER[buffer_line_count_register].low = 0x22;
    REGISTER[buffer_line_count_register].type = BYTE;

    REGISTER[motor_hold_time_register].low = 0x25;
    REGISTER[motor_hold_time_register].type = BYTE;

    REGISTER[motor_back_step_register].low = 0x26;
    REGISTER[motor_back_step_register].type = BYTE;

    REGISTER[darkhead_register].low = 0x27;
    REGISTER[darkhead_register].type = BYTE;

    REGISTER[motor_head_register].low = 0x28;
    REGISTER[motor_head_register].type = BYTE;

    REGISTER[motor_tail_register].low = 0x29;
    REGISTER[motor_tail_register].type = BYTE;

    REGISTER[watchdog_timer_register].low = 0x2b;
    REGISTER[watchdog_timer_register].type = BYTE;

    REGISTER[paper_jam_register].low = 0x2c;
    REGISTER[paper_jam_register].type = BYTE;

    REGISTER[28].low = 0x0A;
    REGISTER[28].type = BYTE;

    brightness = 1.095;
    decontrast = 0.16;
    redadjust = 1.01;
    greenadjust = 1.03;
    blueadjust = 0.99;
    led_bright_adjust = 1.0;

}
