
/***************************************************************************
                          wakeup.c  -  description
                             -------------------
    begin                : Mon Dec 27 1999
    copyright            : (C) 1999 by Eugene S. Weiss
    email                : eweiss@sas.upenn.edu
 ***************************************************************************/

/* Outputs the "magic number" which tells the scanner to turn off the
passthrough mode, and start responding to the port's output.  Credit goes to
Luigi Rizzo's ppscan.c. */

#include "as6edriver.h"
#include "regdata.h"
#include "prototypes.h"

/*--------------------------------------------------------------------------*/

void send_key(int port, int keylen, unsigned char *key)
{
    int i = 0;
    fprintf(LOGd, "sending key, length %d : \n", keylen);
    while (i < keylen) {

	outb_p(key[i], port);

	i++;
    }

    fprintf(LOGd, "sent key %d chars: \n", keylen);
}

/*--------------------------------------------------------------------------*/

// send artec key sequence

void wake_up_scanner(int port)
{
    /* send artec key */
    static unsigned char key[] = {
	/* forward sequence: d3 is a positive clock */
	0x60, 0x68, 0xc0, 0xc8, 0xf0, 0xf8, 0x20, 0x28, 0x10, 0x18,
	0x00,			/* end of sequence */
    };
    send_key(port, sizeof(key), key);
}
